<?php
/*
 * @author Carlos Luis Sánchez Bocanegra
 * Channel file take all envolment elements for our youtube videos feeds.
 * It has all Constants definition
 *  #version 0.0.2
 *  #TODO
 *  
 */
/******************************************************************
 *  Libraries and inclusion variables                              *
 *****************************************************************/
require_once ("Zend/Loader.php");
require_once ("basics.php.inc");

 /*
  * Clase ChannelFeed encargada de reorganizar los canalaes y sacar los videoids
  */

   class ChannelFeed {
       private $canal; //ChannelId
       private $canaluri; //URI feed 
       private $startIndex; //Index of paging on each seek on youtube feed
       private $feed; //This is using for simplexml_load_file and Zend xmlrpc
       private $numVideoIds; //not use
       private $vidarray; //Array where we include videos for including on database
       private $vid; //This is very important determining de nid and vid node properties on table!
         /*
          * Construct method
          * Initialize array vidarray
          * Set vid =1 (initial count nid and vid tables!).
          */
		function __construct($username){
			$this->canal=$username;
			$this->startIndex =1;
			$this->canaluri="";
			$this->feed="";
			$this->total=0;
			$this->numVideoIds=0;
			$this->vidarray= array();
			$this->vid=1;
		    if (DEBUG){
               error_log ("[INFO_ChannelFeed-construct]I have created ChannelFedd object with loadclass Youtube's loadclass.\n",3,DEBUG_FILE);  
            }		
		}

		/*
		 * This function extract the 11 youtube videoid characteres from the YOutube video uri 
		 * 'http://www.youtube.com/watch?v=HjAg4pWxW0A'
		 * this will take 'HjAg4pWxW0A' imprescindible for the node and media_youtube_node table
		 * 
		 * @params $vid: uri of youtube like http://www.youtube.com/watch?v=HjAg4pWxW0A
		 * @return videoID: HjAg4pWxW0A
		 */
		private function getYTid($vid) {
			$ytvIDlen = 11; // This is the length of YouTube's video IDs

			// The ID string starts after "v=", which is usually right after
			// "youtube.com/watch?" in the URL
			$idStarts = strpos($vid, "?v=");

			// In case the "v=" is NOT right after the "?" (not likely, but I like to keep my
			// bases covered), it will be after an "&":
			if($idStarts === FALSE)
				$idStarts = strpos($vid, "&v=");
			// If still FALSE, URL doesn't have a vid ID
			if($idStarts === FALSE)
				error_log("YouTube video ID not found.\n",3,DEBUG_FILE);

			// Offset the start location to match the beginning of the ID string
			$idStarts +=3;

			// Get the ID string and return it
			$ytvID = substr($vid, $idStarts, $ytvIDlen);
			
    		if (DEBUG){
              error_log ("[INFO-ChannelFeed-getYTid]I have the 11 VideoID characteres for returning.\n".$ytvID,3,DEBUG_FILE);  
            }
			return $ytvID;
		}

		/*
		 * This method create a VideoEntry object from the YOutube API entry.
		 * @params videoid is a 11 chars videoid and videEntry is a entry for GDATA.
		 * @return VideoEntry object with all properties
		 */
        private function saveVideoEntry($canalID,$videoid,$videoEntry, $tabs = ""){
          if (DEBUG){
            error_log("[INFO-ChannelFeed-saveVideoEntry]I create a VideoEntry object for ".$videoid." and all datas obtain from GDATA ",3,DEBUG_FILE);
          }
          return (new VideoEntry($videoid, $videoEntry->getVideoTitle(),
                      $videoEntry->getVideoDescription(),
                      $videoEntry->getVideoCategory(),
                      $videoEntry->getVideoTags(),
                      $videoEntry->getVideoWatchPageUrl(),
                      $videoEntry->getFlashPlayerUrl(),
                      $videoEntry->getVideoDuration(),
                      $videoEntry->getVideoViewCount(),
                      $videoEntry->getVideoRatingInfo(),
                      $videoEntry->getVideoGeoLocation(),
                      $canalID));
         }

		/*
		 * This partial method take a portion of feed (start+max) for display on array -> vidarray
		 * @params $canal Uri Channel
		 * @returns URI array of channel videos that contains in it.
		 * @return false if there is no more feeds
		 */
		private function showFullFeedPartial($canal, $channelID){
		  $yt = new Zend_Gdata_YouTube();
     		  $feedpartial = $yt->getVideoFeed($canal);
     		  $contador = 0;
  		  foreach($feedpartial as $video){
  		    try{
  		       if (($video->isVideoPrivate()) || (!($video->isVideoEmbeddable())) ){
  		         throw new Exception("Video not embeddable or private");
               }
               $videoid = $this->getYTid($video->getVideoWatchPageUrl());
               if (DEBUG){
                  error_log ("\t[ChannelFeed-showFullFeedPartial]Video: ".$videoid." - ". $video->getVideoWatchPageUrl()."\n",3,DEBUG_FILE);
               }
    		    if($videoid != ""){
                  $this->vidarray[] = $this->saveVideoEntry($channelID,$videoid,$video);
                  $contador ++;
                }else{
                  $contador = 0;
                }
  		      }catch(Exception $e){
  		       if (DEBUG){
  		           error_log("[ERROR-ChannelFeed-showFullFeedPartial]This video does not exists.\n",3,DEBUG_FILE);
  		       }
  		     }
	    	 }
		  if ($contador == 0){
		    return false;
		  }else{
		    return true;
		  }
		}
		
		/*
		 * This method treat the hole feed of one channel , paging every MAX 
		 * Use the showFullPartial($feedpartial) function
		 * (If the video gives a "" url means that there no more feeds)
		 */
		private function showFullFeed(){
		  $indice = 1;
		  $this->vidarray = array();
		  $feed = "";
		  $haymas = true;
		  do{
		      $canal=GDATA.$this->canal->ChannelID().START_INDEX.$indice.MAX_RESULTS;
    		  $haymas = $this->showFullFeedPartial($canal,$this->canal->ChannelID());
		      $indice += MAXRESULT;
              if (DEBUG){
                error_log ("[INFO_ChannelFeed-showFullFeed]Canal:".$canal,3,DEBUG_FILE);		      
              }
		  }while($haymas);
		}
	
		/*
		 * This function take the 3 tables: nodes, media_youtube_node, node_revisions, content_type_healthvideos for erasing
		 * @Deprecated on next version!
		 * The function is treat to insert new values....but it possible to loose statitics node.
		 * TODO
		 * Get a better solution for db connect (using objects).
		 */
        public static function borrar(){
  		    $conn= mysql_connect(HOST,USER,PASS);
          	mysql_select_db(BBDD,$conn);
              $res= mysql_query("DELETE FROM media_youtube_node_data");
              $res= mysql_query("DELETE FROM node_revisions");
              $res= mysql_query("DELETE FROM node");
              $res= mysql_query("DELETE FROM content_type_".NAMEMEDIA);
              $vid=1;
            mysql_close($conn);
            if (DEBUG){
              error_log("[INFO_ChannelFeed]Bases de datos limpias\n",3,DEBUG_FILE);
            }
       }		
        /*
         * This method call showFullFeed.
         * 
         * After this will store on each table from vidarray and vid number id.
         *
         * @params @vid id for nid and vid tables !IMPORTANT to be unique
         * @return new @vid after include more videos.
         */
		public function guardarvideosIds($vid){
		  $this->showFullFeed();
		  
          if (DEBUG){
            error_log ("[INFO_ChannelFeed-guardarvideosIds]Volcando a bbdd",3,DEBUG_FILE);	
          }
          $conn= mysql_connect(HOST,USER,PASS);
          mysql_select_db(BBDD,$conn);
          foreach($this->vidarray as $video){
                // Tabla 'node'
                $sql= "INSERT INTO node (nid,vid,uid,type,title,promote,sticky) VALUES (".$vid.",".$vid.",1,'".NAMEMEDIA."','".mysql_real_escape_string(utf8_decode($video->title()))."',1,1)";
            	$res= mysql_query($sql);      	
                // Tabla node_revisions
            	$sql= "INSERT INTO node_revisions (nid,vid,uid,title,body) 
            						VALUES (".$vid.",".$vid.",1,'".mysql_real_escape_string(utf8_decode($video->title()))."','<div align=\"justify\">.".mysql_real_escape_string(utf8_decode($video->description()))."</div>')";
            	$res=mysql_query($sql);
            	       	
            	//Tabla media_youtube_node_data
            	$sql= "INSERT INTO media_youtube_node_data (value,nid,field_name,ChannelID)
            						VALUES ('".$video->videoid()."',".$vid.",'field_video_url','".$video->channelID()."')";
            	$res= mysql_query($sql);
            	       			
            	// Tabla content_type_raredisease
            	$sql = "INSERT INTO content_type_".NAMEMEDIA." (vid,nid, field_video_url_embed, field_video_url_value, field_video_url_provider,field_video_url_title,field_video_url_description,field_video_url_duration)
            			VALUES (".$vid.",".$vid.",'http://www.youtube.com/embed/".$video->videoid()."','".$video->videoid()."','youtube','".mysql_real_escape_string(utf8_decode($video->title()))."','".mysql_real_escape_string(utf8_decode($video->description()))."',".$video->duration().")";
            	$res= mysql_query($sql);

            	if(DEBUG){
            	  error_log("[INFO_ChannelFeed-guardarVideosIds]Registro insertado".$video->__toString()."\n",3,DEBUG_FILE);
            	}
            	$vid ++;
            }
          	mysql_close($conn);
          	return $vid;    
		  }
	};
	
    /*
     * This class takes media_youtube_channel and select channel for getting feeds on each other.
     */
   class ChannelsFeed {
     private $listacanales; //Array for getting URI channels
     private $vid; //Identification for nid and vid tables ImPORTANT
     /*
      * @TODO 
      *   Getting a better solution for connect database -> using objects
      *   	
      */
     function __construct($Channelfeed = "", $filtro =""){
            Zend_Loader::loadClass('Zend_Gdata_YouTube');
            
            $conn= mysql_connect(HOST,USER,PASS);
            
        	mysql_select_db(BBDD,$conn);
        	$sql = "SELECT * from media_youtube_channel ";
        	if ($filtro!=""){
        	 $sql.= " where (Type='".$filtro."') ";
        	}
            if ($Channelfeed != ""){
              if ($filtro!=""){
                $sql.= " AND (ChannelID='".$Channelfeed."') ";
              }else{
                $sql.= " WHERE (ChannelID='".$Channelfeed."') ";                
              }
            }
        	//$sql.= " order by ChannelID";
            $this->listacanales= array();
            $res= mysql_query($sql);
            while($row=mysql_fetch_object($res)){
              $micanal= new Channel($row->IdChannel, $row->ChannelID);
              $this->listacanales[]= $micanal;
              if (DEBUG){
                error_log("[INFO_ChannelsFeed-construct]Canal insertado: ".$micanal->channelId()."\n",3,DEBUG_FILE);
              }
            }
            $this->vid=1;
            mysql_close($conn);
     }
     /*
      * call guardarvideosId for storing data on node tables and return the new vid id for another tables.
      */
     public function cargaChannels($filtro =""){
       ChannelFeed::borrar(); //limpieza de lo que había.
       
       foreach($this->listacanales as $canal){
         try{
           $youtube = new ChannelFeed($canal);
           
           $this->vid=$youtube->guardarvideosIds($this->vid);
           if (DEBUG){
             error_log ("[INFO_ChannelsFeed-cargaChannels]Analizando canal".$canal->ChannelID()." con el contador".$this->vid."\n",3,DEBUG_FILE);
           }
         }catch(Exception $e){
           if (DEBUG){
             error_log ("[ERROR_ChannelsFeed-cargaChannels]Error en Zend\n",3,DEBUG_FILE);
           }  
         } 
       }
     }
   }
?>
